# PlotUtils

[![CI](https://github.com/JuliaPlots/PlotUtils.jl/actions/workflows/ci.yml/badge.svg)](https://github.com/JuliaPlots/PlotUtils.jl/actions/workflows/ci.yml)
[![project chat](https://img.shields.io/badge/zulip-join_chat-brightgreen.svg)](https://julialang.zulipchat.com/#narrow/stream/236493-plots)
[![Coverage Status](https://codecov.io/gh/JuliaPlots/PlotUtils.jl/branch/master/graphs/badge.svg?branch=master)](https://app.codecov.io/gh/JuliaPlots/PlotUtils.jl)
[![PlotUtils Downloads](https://img.shields.io/badge/dynamic/json?url=http%3A%2F%2Fjuliapkgstats.com%2Fapi%2Fv1%2Fmonthly_downloads%2FPlotUtils&query=total_requests&suffix=%2Fmonth&label=Downloads)](https://juliapkgstats.com/pkg/PlotUtils)

# --------------------------------------------------------------

# Methods to automatically generate colorschemes for color selection based on
# background color and a short list of seed colors

# here are some magic constants that could be changed if you really want
const _lightness_darkbg = Ref(80.0)
const _lightness_lightbg = Ref(60.0)
const _lch_c_const = Ref(60)

adjust_lch(color, l, c) = convert(RGBA{Float64}, LCHab(l, c, convert(LCHab, color).h))

function lightness_from_background(bgcolor)
    bglight = convert(LCHab, bgcolor).l
    bglight < 50.0 ? _lightness_darkbg[] : _lightness_lightbg[]
end

function generate_colorscheme(
    bgcolor = plot_color(:white);
    color_bases = plot_color([colorant"steelblue", colorant"orangered"]),
    lightness = lightness_from_background(bgcolor),
    chroma = _lch_c_const[],
    n = 17,
)
    seed_colors = vcat(bgcolor, map(c -> adjust_lch(c, lightness, chroma), color_bases))
    seed_colors = convert(Vector{RGB{Float64}}, seed_colors)
    colors = distinguishable_colors(
        n,
        seed_colors,
        lchoices = Float64[lightness],
        cchoices = Float64[chroma],
        hchoices = range(0; stop = 340, length = 20),
    )[2:end]
    ColorScheme(colors)
end

# ----------------------------------------------------------------------------------

function getpctrange(n::Integer)
    n > 0 || error()
    n == 1 && return zeros(1)
    zs = [0.0, 1.0]
    for i ∈ 3:n
        sorted = sort(zs)
        diffs = diff(sorted)
        widestj = 0
        widest = 0.0
        for (j, d) ∈ enumerate(diffs)
            if d > widest
                widest = d
                widestj = j
            end
        end
        push!(zs, sorted[widestj] + 0.5diffs[widestj])
    end
    zs
end

function get_zvalues(n::Integer)
    offsets = getpctrange(ceil(Int, n / 4) + 1) / 4
    offsets = vcat(offsets[1], offsets[3:end])
    zvalues = Float64[]
    for offset ∈ offsets
        append!(zvalues, offset .+ [0.0, 0.5, 0.25, 0.75])
    end
    vcat(zvalues[1], 1.0, zvalues[2:(n - 1)])
end

# ----------------------------------------------------------------------------------

function darken(c, v = 0.1)
    rgba = convert(RGBA, c)
    r = max(0, min(rgba.r - v, 1))
    g = max(0, min(rgba.g - v, 1))
    b = max(0, min(rgba.b - v, 1))
    RGBA(r, g, b, rgba.alpha)
end
lighten(c, v = 0.3) = darken(c, -v)

# borrowed from http://stackoverflow.com/a/1855903:
lightness_level(c::Colorant) = 0.299red(c) + 0.587green(c) + 0.114blue(c)

isdark(c::Colorant)::Bool = lightness_level(c) < 0.5
islight(c::Colorant)::Bool = !isdark(c)

Base.convert(::Type{RGB}, h::Unsigned) =
    RGB([(x & 0x0000FF) / 0xFF for x ∈ (h >> 16, h >> 8, h)]...)

make255(x)::Int = round(Int, 255 * x)

rgb_string(c::Colorant) =
    @sprintf("rgb(%d, %d, %d)", make255(red(c)), make255(green(c)), make255(blue(c)))

rgba_string(c::Colorant) = @sprintf(
    "rgba(%d, %d, %d, %1.3f)",
    make255(red(c)),
    make255(green(c)),
    make255(blue(c)),
    alpha(c)
)

module PlotUtils

using PrecompileTools
using ColorSchemes
using Reexport
using Printf
using Dates

@reexport using Colors
import Base: getindex
import StableRNGs: StableRNG

export ColorGradient,
    ColorPalette,
    cgrad,
    palette,
    color_list,
    cvec,
    rgb_string,
    rgba_string,
    invisible,
    get_color_palette,
    isdark,
    plot_color,
    adapted_grid,
    default_cgrad,
    zscale

include("color_utils.jl")
include("colors.jl")
include("colorschemes.jl")
include("adapted_grid.jl")
include("intervals.jl")

export optimize_ticks, optimize_datetime_ticks

include("ticks.jl")

const _default_colorscheme = generate_colorscheme()

if VERSION ≥ v"1.8.0"
    @compile_workload begin
        for T in (Int, Float64)
            optimize_ticks(-one(T), one(T))
            optimize_ticks(-one(T), one(T); k_min = 2, k_max = 10)
            adapted_grid(sin, (-one(T), one(T)))
            zscale(one(T):10)
            cgrad([:red, :blue], T[0, 1])
        end
        cgrad()
        cgrad([:red, :blue])
        palette(:viridis)
        optimize_datetime_ticks(Dates.value(DateTime(2_000)), Dates.value(DateTime(2_100)))
    end
end

end

using Pkg

LibGit2 = Pkg.GitTools.LibGit2
TOML = Pkg.TOML

failsafe_clone_checkout(path, toml, url) = begin
    local repo
    for i in 1:6
        try
            repo = Pkg.GitTools.ensure_clone(stdout, path, url)
            break
        catch err
            @warn err
            sleep(20i)
        end
    end

    @assert isfile(toml) "spurious network error: clone failed, bailing out"

    name, _ = splitext(basename(url))
    registries = joinpath(first(DEPOT_PATH), "registries")
    general = joinpath(registries, "General")
    versions = joinpath(general, name[1:1], name, "Versions.toml")
    if !isfile(versions)
        mkpath(general)
        run(setenv(`tar xf $general.tar.gz`; dir = general))
    end
    @assert isfile(versions)

    stable = maximum(VersionNumber.(keys(TOML.parse(read(versions, String)))))
    tag = LibGit2.GitObject(repo, "v$stable")
    hash = string(LibGit2.target(tag))
    LibGit2.checkout!(repo, hash)
    nothing
end

fake_supported_version!(path, toml) = begin
    # fake the supported PlotUtils version for testing (for `Pkg.develop`)
    PlotUtils_version =
        Pkg.Types.read_package(normpath(@__DIR__, "..", "Project.toml")).version
    parsed_toml = TOML.parse(read(toml, String))
    parsed_toml["compat"]["PlotUtils"] = string(PlotUtils_version)
    open(toml, "w") do io
        TOML.print(io, parsed_toml)
    end
    nothing
end

scratch_env_with_PlotUtils() = begin
    Pkg.activate(; temp = true)
    Pkg.develop(path = normpath(@__DIR__, ".."))  # PlotUtils
    nothing
end

develop_stable_Plots() = begin
    scratch_env_with_PlotUtils()
    tmpd = mktempdir()
    Plots_jl = joinpath(tmpd, "Plots.jl")
    toml = joinpath(Plots_jl, "Project.toml")

    failsafe_clone_checkout(Plots_jl, toml, "https://github.com/JuliaPlots/Plots.jl")
    fake_supported_version!(Plots_jl, toml)

    Pkg.develop(path = Plots_jl)
    Pkg.status(["PlotUtils", "Plots"])
    nothing
end

develop_stable_Makie(extended = false) = begin
    scratch_env_with_PlotUtils()
    tmpd = mktempdir()
    Makie_jl = joinpath(tmpd, "Makie.jl")
    toml = joinpath(Makie_jl, "Makie", "Project.toml")

    failsafe_clone_checkout(Makie_jl, toml, "https://github.com/MakieOrg/Makie.jl")
    fake_supported_version!(Makie_jl, toml)

    Pkg.develop(path = joinpath(tmpd, "Makie.jl", "ComputePipeline"))
    Pkg.develop(path = joinpath(tmpd, "Makie.jl", "Makie"))
    extended && Pkg.develop(path = joinpath(tmpd, "Makie.jl", "ReferenceTests"))
    Pkg.develop(path = joinpath(tmpd, "Makie.jl", "CairoMakie"))
    # Pkg.develop(path = joinpath(tmpd, "Makie.jl", "GLMakie"))
    Pkg.status(["PlotUtils", "Makie"])
    nothing
end

using PlotUtils, Test

const DEBUG = true

@testset "downstream Plots" begin
    script = tempname()
    write(
        script,
        """
        include(joinpath("$(@__DIR__)", "dev_downstream.jl"))
        develop_stable_Plots()
        using Plots

        # test basic plots creation & display (Plots tests are too long to run)
        withenv("GKSwstype" => "nul") do
            @time for i in 1:length(Plots._examples)
                i ∈ Plots._backend_skips[:gr] && continue  # skip unsupported examples
                Plots._examples[i].imports ≡ nothing || continue  # skip examples requiring optional test deps
                show(devnull, Plots.test_examples(:gr, i; disp = false))  # trigger display logic
            end
        end
        exit()
        """,
    )
    DEBUG && print(read(script, String))
    @test run(```$(Base.julia_cmd()) $script```) |> success
    rm(script)
end

const EXTENDED = tryparse(Bool, get(ENV, "CI", "false")) === true  # extended test in CI

@testset "downstream Makie" begin
    script = tempname()
    write(
        script,
        """
        include(joinpath("$(@__DIR__)", "dev_downstream.jl"))
        develop_stable_Makie($EXTENDED)
        using CairoMakie

        Pkg.test("Makie")
        # $EXTENDED && Pkg.test("CairoMakie")

        let f = Figure()  # taken from https://docs.makie.org/dev/reference/blocks/axis#yscale
            for (i, scale) in enumerate([identity, log10, log2, log, sqrt, Makie.logit])
                row, col = fldmod1(i, 3)
                Axis(
                    f[row, col], yscale = scale, title = string(scale),
                    yminorticksvisible = true, yminorgridvisible = true,
                    yminorticks = IntervalsBetween(5)
                )
                lines!(range(0.01, 0.99, length = 200))
            end

            fn = tempname() * ".png"
            save(fn, f)
            @assert isfile(fn)
            rm(fn)
        end

        exit()
        """,
    )
    DEBUG && print(read(script, String))
    @test run(```$(Base.julia_cmd()) $script```) |> success
    rm(script)
end

@testset "adaptative test Plots" begin
    script = tempname()
    write(
        script,
        """
        include(joinpath("$(@__DIR__)", "dev_downstream.jl"))
        develop_stable_Plots()
        using Plots

        let test_funcs = (
            (x -> 2, 0, 1),
            (x -> x, -1, 1),
            (x -> 5x, -1, 1),
            (x -> 1 / x, 0, 1),
            (x -> 1 / x, -1, 1),
            (x -> tan(x), 0, 4),
            (x -> -1 / x, 0, 1),
            (x -> 1 / abs(x), -1, 1),
            (x -> 1.0e6x, -1, 1),
            (x -> 1.0e50x, -1, 1),
            (x -> log(1 + sin(cos(x))), -6, 6),
            (x -> sin(x^3) + cos(x^3), 0, 6.28),
            (x -> sin(x), -5, 200),
            (x -> sin(1 / x), -2, 2),
            (x -> sin(1 / x), 0, 2),
            (x -> sin(x^4), -4, 4),
            (x -> sin(300x), -4, 4),
            (x -> 1 + x^2 + 0.0125log(abs(1 - 3(x - 1))), -2, 2),
            (x -> sin(exp(x)), -6, 6),
            (x -> 1 / sin(x), -10, 10),
            (x -> sin(x) / x, -6, 6),
            (x -> tan(x^3 - x + 1) + 1 / (x + 3exp(x)), -2, 2),
        )
            plots = [plot(func...) for func in test_funcs]

            pitchfork = plot(x -> sqrt(x), 0, 10)
            plot!(pitchfork, x -> -sqrt(x), 0, 10)
            plot!(pitchfork, x -> 0, -10, 0)
            plot!(pitchfork, x -> 0, 0, 10, linestyle = :dash)
            push!(plots, pitchfork)

            np = length(plots)
            m = ceil(Int, √(np)) + 1
            n, r = divrem(np, m)
            r == 0 || (n += 1)
            append!(plots, [plot() for _ in 1:(m * n - np)])

            @assert length(plots) == m * n

            png(plot(plots...; layout = (m, n), size = (m * 600, n * 400)), "grid")
        end
        """,
    )
    DEBUG && print(read(script, String))
    @test run(```$(Base.julia_cmd()) $script```) |> success
    rm(script)
end

using Statistics: mean
using StableRNGs
using PlotUtils
using Random
using Dates
using Test

rng = StableRNG(42)
warn_ticks = :warn, "No strict ticks found"

# ----------------------
# colors

const C = RGBA{Float64}
const C0 = RGBA{PlotUtils.Colors.N0f8}

bool_env(x, default::String = "0")::Bool = tryparse(Bool, get(ENV, x, default))

is_ci() = bool_env("CI")
is_64b() = Sys.WORD_SIZE == 64

@testset "colors" begin
    @test plot_color(nothing) == C(0, 0, 0, 0)
    @test plot_color(false) == C(0, 0, 0, 0)
    @test_throws ErrorException plot_color(true)

    @test plot_color(:red) == parse(C, :red)
    @test plot_color("red") == parse(C, "red")
    @test_throws ArgumentError plot_color("notacolor")

    @test plot_color(colorant"red") == C(1, 0, 0, 1)

    grad = cgrad()
    @test typeof(grad) == PlotUtils.ContinuousColorGradient
    @test plot_color(grad) ≡ grad

    # JuliaPlots/Plots.jl/issues/4270
    @test get(grad, BigFloat(1), (-0.0003354626279, 1.0)) isa RGBA{BigFloat}

    grad = cgrad([:red, "blue"])
    @test color_list(grad) == C[colorant"red", colorant"blue"]
    @test grad.values == collect(range(0, stop = 1, length = 2))

    grad = cgrad([:red, "blue"], alpha = 0.5)
    @test C0.(color_list(grad)) == C0[C(1, 0, 0, 0.5), C(0, 0, 1, 0.5)]
    @test grad.values == collect(range(0, stop = 1, length = 2))

    grad = cgrad([:red, :blue], [0, 0.1, 1])
    @test length(color_list(grad)) == 3
    @test grad.values == [0, 0.1, 1]

    Random.seed!(rng, 42)
    cs = plot_color(rand(rng, 10))
    @test typeof(cs) == Vector{C}
    @test length(cs) == 10

    cs = plot_color(rand(rng, 4, 4))
    @test typeof(cs) == Matrix{C}
    @test length(cs) == 16
    @test size(cs) == (4, 4)

    cs = plot_color(rand(rng, 10), 0.5)
    @test typeof(cs) == Vector{C}
    @test length(cs) == 10
    for c in cs
        @test alpha(c) == 0.5
    end

    cs = plot_color(rand(rng, 4, 4), 0.5)
    @test typeof(cs) == Matrix{C}
    @test length(cs) == 16
    @test size(cs) == (4, 4)
    for c in cs
        @test alpha(c) == 0.5
    end
end

# ----------------------
# gradients

@testset "gradients" begin
    grad = cgrad(:inferno)
    @test length(grad) == 256
    @test RGB(grad.colors[1]) ≈ RGB(0.001462, 0.000466, 0.013866)
    @test RGB(grad.colors[end]) ≈ RGB(0.988362, 0.998364, 0.644924)
end

@testset "sampling" begin
    # github.com/MakieOrg/Makie.jl/issues/2635
    cmap = cgrad([:black, :white, :orange], [0, 0.2, 1])
    # sample outside the given values
    @test RGB(get(cmap, 0.15)) ≈ RGB(0.75, 0.75, 0.75)
    @test RGB(get(cmap, 0.5)) ≈ RGB(1.0, 0.86764705, 0.625)
    @test RGB(get(cmap, 0.8)) ≈ RGB(1.0, 0.73529411, 0.25)
end

@testset "reverse" begin
    cmap = reverse(cgrad([:black, :white, :orange], [0, 0.2, 1]))
    # sample outside the given values
    @test RGB(get(cmap, 0.15)) ≈ RGB(1.0, 0.71323529, 0.1875)
    @test RGB(get(cmap, 0.5)) ≈ RGB(1.0, 0.86764705, 0.625)
    @test RGB(get(cmap, 0.75)) ≈ RGB(1.0, 0.97794117, 0.9375)
end

# ----------------------
# ticks

# Copied from Plots.is_uniformly_spaced to avoid dependency on recent version
# on Plots which is not used on Travis.
function is_uniformly_spaced(v; tol = 1.0e-6)
    dv = diff(v)
    return maximum(dv) - minimum(dv) < tol * mean(abs.(dv))
end

function test_ticks(x, y, ticks)
    @test issorted(ticks)
    @test all(x .≤ ticks .≤ y)
    return if x < y
        @test length(ticks) ≥ 2
        @test is_uniformly_spaced(ticks)
    end
end

@testset "ticks" begin
    @test optimize_ticks(-1, 2) == ([-1.0, 0.0, 1.0, 2.0], -1.0, 2.0)

    # check if ticks still generate if max - min << abs(min) (i.e. for Float64 ranges)
    is_64b() &&
        @test optimize_ticks(1.0e11 - 1, 1.0e11 + 2) == (1.0e11 .+ (-1:2), 1.0e11 - 1.0, 1.0e11 + 2.0)

    @testset "dates" begin
        dt1, dt2 = Dates.value(DateTime(2000)), Dates.value(DateTime(2100))
        @test optimize_datetime_ticks(dt1, dt2) == (
            [63113990400000, 63902908800000, 64691827200000, 65480745600000],
            ["2001-01-01", "2026-01-01", "2051-01-01", "2076-01-01"],
        )
    end

    @testset "small range" begin
        @testset "small range $x, $(i)ϵ" for x in exp10.(-12:12), i in -5:5
            y = x + i * eps(x)
            x, y = minmax(x, y)
            ticks, = optimize_ticks(x, y)
            @test issorted(ticks)
            @test all(x .≤ ticks .≤ y)
            # Fails:
            # @test allunique(ticks)
        end
    end

    @testset "fixed ranges" begin
        @testset "fixed range $x..$y" for (x, y) in [(2, 14), (14, 25), (16, 36), (57, 69)]
            test_ticks(+x, +y, optimize_ticks(+x, +y)[1])
            test_ticks(-y, -x, optimize_ticks(-y, -x)[1])
        end
    end

    @testset "random ranges" begin
        r = [minmax(rand(rng, -100:100, 2)...) .* 10.0^i for _ in 1:10, i in -5:5]
        @testset "random range $x..$y" for (x, y) in r
            test_ticks(x, y, optimize_ticks(x, y)[1])
        end
    end

    @testset "digits" begin
        @testset "digits $((10^n) - 1)*10^$i" for n in 1:9, i in -9:9
            (!is_64b() && n ≥ 9) && continue
            y0 = 10^n
            x0 = y0 - 1
            x, y = (x0, y0) .* 10.0^i
            ticks, = optimize_ticks(x, y)
            test_ticks(x, y, ticks)
        end
    end

    @testset "types" begin
        for T in (Int32, Int64, Float16, Float32, Float64)
            x, y = T(1), T(10)
            ticks, = optimize_ticks(x, y)
            @test eltype(ticks) <: AbstractFloat
            @test eltype(ticks) == (T <: AbstractFloat ? T : float(T))
            test_ticks(x, y, ticks)
        end
    end

    @testset "issues" begin
        @testset "PlotUtils.jl/issues/86" begin
            let x = -1.0, y = 13.0
                test_ticks(x, y, optimize_ticks(x, y, k_min = 4, k_max = 8)[1])
            end
        end

        @testset "Plots.jl/issues/3859" begin
            x, y = extrema([-1.7055509600077687e307, -1.3055509600077687e307, -1.0e300])
            test_ticks(x, y, optimize_ticks(x, y, k_min = 4, k_max = 8)[1])
        end

        @testset "PlotUtils.jl/issues/114" begin
            let x = -1.2eps(), y = 1.2eps()
                test_ticks(x, y, optimize_ticks(x, y)[1])
            end
        end

        @testset "PlotUtils.jl/issues/116" begin
            let x = 4.5, y = 5.5
                test_ticks(x, y, optimize_ticks(x, y, scale = :log10)[1])
            end
            let x = 2.5, y = 3.5
                test_ticks(x, y, optimize_ticks(x, y, scale = :log2)[1])
            end
            let x = 0.5, y = 1.5
                test_ticks(x, y, optimize_ticks(x, y, scale = :ln)[1])
            end
        end

        @testset "PlotUtils.jl/issues/129" begin
            # invalid float input
            let x = NaN, y = 1.0
                ticks, = @test_logs warn_ticks optimize_ticks(x, y)
                @test isnan(ticks[1])
                @test ticks[2] ≡ y
                ticks, = @test_logs warn_ticks optimize_ticks(x, y, k_min = 5)
                @test isnan(ticks[1])
                @test ticks[2] ≡ y
            end
            let x = 0.0f0, y = Inf32
                ticks, = @test_logs warn_ticks optimize_ticks(x, y)
                @test ticks[1] ≡ x
                @test isinf(ticks[2])
                ticks, = @test_logs warn_ticks optimize_ticks(x, y, k_min = 5)
                @test ticks[1] ≡ x
                @test isinf(ticks[2])
            end
        end
    end

    @testset "PlotUtils.jl/issues/155" begin
        for n in 1:10
            @test length(palette(:tab10, n)) == n
        end
    end

    @testset "PlotUtils.jl/issues/156" begin
        for c in cgrad([:black, RGBA{Float64}(1, 1, 1, 1)], 5; categorical = true)
            @test 0 ≤ alpha(c) ≤ 1
        end
    end
end

@testset "adapted grid" begin
    let f = sin, int = (0, π)
        xs, fs = adapted_grid(f, int)
        for i in 1:(length(xs) - 1)
            for λ in 0:0.1:1
                # test that `f` is well approximated by a line
                # in the interval `(xs[i], xs[i+1])`
                x = λ * xs[i] + (1 - λ) * xs[i + 1]
                y = λ * fs[i] + (1 - λ) * fs[i + 1]
                @test y ≈ f(x) atol = 1.0e-2
            end
        end
    end

    let f = sin, int = (2, 2)
        xs, fs = adapted_grid(f, int)
        @test xs == [2]
        @test fs == [f(2)]
    end

    let f = sin, int = (2, 1)
        @test_throws ArgumentError adapted_grid(f, int)
    end

    p(x) = (x < 0.0 || x > 1.0 ? 0.0 : 1.0 + x)
    let f = x -> p(2(x - 3)), int = (-5, 5)  # JuliaPlots/Plots.jl/issues/4106
        xs, fs = adapted_grid(f, int)
        @test count(fs .> 1.5) > 10
        @test fs |> extrema |> collect |> diff |> first > 1.9
    end

    let f = sinc, int = (-40, 40)  # JuliaPlots/Plots.jl/issues/3894
        xs, fs = adapted_grid(sinc, int)
        roots = vcat(int[1]:-1, 1:int[2])
        count_per_extrema = map(1:(length(roots) - 1)) do idx
            left, right = roots[idx:(idx + 1)]
            return count(x -> left < x < right, xs)
        end
        # check that we have at least 5 points for each extrema
        @test all(count_per_extrema .>= 5)
    end
end

@testset "zscale" begin
    Random.seed!(rng, 42)
    bkg = 30 .* randn(rng, 4_096) .+ 1_000
    data = bkg .+ 100 .* randn(rng, 4_096) .+ 2500
    defects = rand(rng, CartesianIndices(bkg), 500)
    data[defects] .= rand(rng, [0, 1.0e7], 500)
    cmin, cmax = zscale(data)
    # values calculated using IRAF
    @test cmin ≈ 2_784.824 atol = 1.0e-3
    @test cmax ≈ 4_211.375 atol = 1.0e-3
    @test cmin > minimum(data)
    @test cmax < maximum(data)

    data = vcat(1:100)
    cmin, cmax = zscale(data)
    @test cmin == 1
    @test cmax == 100

    # make sure output is finite
    data = vcat(0:999, NaN)
    cmin, cmax = zscale(data)
    @test cmin == 0
    @test cmax == 999
end

@testset "allocations" begin  # see PlotUtils.jl/pull/136
    optimize_ticks(0.1123, 100.132)  # warmup
    stats = @timed optimize_ticks(0.1123, 100.132)
    @test stats.bytes < 3_000  # ~ 2_896 (on 1.12)
    @test stats.time < 2.0e-3  # ~ 0.21ms (on 1.12)
    #=
    history:
    ~ 736B (on 1.9)
    ~ 0.22ms (on 1.9)
    =#
end

(
    Sys.islinux() &&
        VERSION ≥ v"1.11.0" &&
        isempty(VERSION.prerelease) &&  # avoid running on `nightly`
        is_64b() && (
        !is_ci() || (is_ci() && get(ENV, "GITHUB_EVENT_NAME", "pull_request") == "pull_request")
    )
) && @testset "downstream" begin
    include("downstream.jl")
end

invisible() = RGBA{Float64}(0.0, 0.0, 0.0, 0.0)

# the one-arg cases, meant for single colors
plot_color(s::AbstractString) = parse(RGBA{Float64}, s)
plot_color(s::Symbol) =
    try
        parse(RGBA{Float64}, s)
    catch e
        is_colorscheme(s) ? cgrad(s) : rethrow(e)
    end
plot_color(b::Val{true}) = error("plot_color(true) not allowed.")
plot_color(b::Val{false}) = invisible()
plot_color(b::Bool) = plot_color(Val(b))
plot_color(::Nothing) = invisible()
plot_color(c::Colorant) = convert(RGBA{Float64}, c)
# plot_color(cs::AbstractVector) = RGBA{Float64}[plot_color(c) for c ∈ cs]
# plot_color(cs::AbstractArray) = map(plot_color, cs)

# no alpha override
plot_color(x, ::Nothing) = plot_color(x)

# alpha override
plot_color(x, α::Number) = RGBA{Float64}(convert(RGB, plot_color(x)), α)
plot_color(c::Colorant, α::Number) = RGBA{Float64}(red(c), green(c), blue(c), α)
plot_color(s::Symbol, α::Number) = (
    is_colorscheme(s) ? cgrad(s, alpha = α) : RGBA{Float64}(convert(RGB, plot_color(s)), α)
)

function plot_color(cs::AbstractArray)
    a = Array{RGBA{Float64}}(undef, size(cs)...)
    for i ∈ eachindex(cs)
        a[i] = plot_color(cs[i])
    end
    a
end

# plot_color(cs::AbstractVector, α::Number) = RGBA{Float64}[plot_color(c,α) for c ∈ cs]
function plot_color(cs::AbstractArray, α::Number)
    a = Array{RGBA{Float64}}(undef, size(cs)...)
    for i ∈ eachindex(cs)
        a[i] = plot_color(cs[i], α)
    end
    a
end
# map!(c -> plot_color(c,α), a, cs))

# convenience conversions from numeric arrays to gradient values
# note: we need the first version because of dispatch
# function plot_color(zs::AbstractVector{T}) where T<:Number
#     grad = cgrad()
#     zmin, zmax = extrema(zs)
#     RGBA{Float64}[grad[(z-zmin)/(zmax-zmin)] for z ∈ zs]
# end
function plot_color(zs::AbstractArray{T}) where {T<:Number}
    grad = cgrad()
    zmin, zmax = extrema(zs[isfinite.(zs)])
    a = Array{RGBA{Float64}}(undef, size(zs)...)
    for i ∈ eachindex(zs)
        a[i] = grad[(zs[i] - zmin) / (zmax - zmin)]
    end
    a
end

# function plot_color(zs::AbstractVector{T}, α::Number) where T<:Number
#     cs = plot_color(zs)
#     RGBA{Float64}[RGBA{Float64}(convert(RGB, c), α) for c ∈ cs]
# end
function plot_color(zs::AbstractArray{T}, α::Number) where {T<:Number}
    cs = plot_color(zs)
    a = Array{RGBA{Float64}}(undef, size(zs)...)
    for i ∈ eachindex(zs)
        a[i] = RGBA{Float64}(convert(RGB, cs[i]), α)
    end
    a
end

const _logScales = (:ln, :log2, :log10)
const _logScaleBases = Dict(:ln => ℯ, :log2 => 2.0, :log10 => 10.0)

# NOTE: This file was moved from Gadfly.jl, and the original author is Daniel Jones (@dcjones)

# Find the smallest order of magnitude that is larger than xspan This is a
# little opaque because I want to avoid assuming the log function is defined
# over typeof(xspan)
function bounding_order_of_magnitude(xspan::T, base::T) where {T}
    a = step = 1
    while xspan < base^a
        a -= step
    end

    b = step = 1
    while xspan > base^b
        b += step
    end

    while a + 1 < b
        c = div(a + b, 2)
        if xspan < base^c
            b = c
        else
            a = c
        end
    end

    return b
end

function postdecimal_digits(x::T) where {T}
    for i ∈ floor(Int, log10(floatmin(T))):ceil(Int, log10(floatmax(T)))
        x == floor(x; digits = i) && return i
    end
    return 0
end

function fallback_ticks(x_min::T, x_max::T, k_min, k_max, strict_span) where {T}
    if !strict_span && x_min ≈ x_max
        x_min, x_max = prevfloat(x_min), nextfloat(x_max)
    end
    if k_min != 2 && isfinite(x_min) && isfinite(x_max)
        collect(T, range(x_min, x_max; length = k_min)), x_min, x_max
    else
        T[x_min, x_max], x_min, x_max
    end
end

# Empty catchall
optimize_ticks() = Any[]

"""
optimize_ticks(xmin, xmax; extend_ticks::Bool = false,
               Q = [(1.0,1.0), (5.0, 0.9), (2.0, 0.7), (2.5, 0.5), (3.0, 0.2)],
               k_min = 2, k_max = 10, k_ideal = 5,
               granularity_weight = 1/4, simplicity_weight = 1/6,
               coverage_weight = 1/3, niceness_weight = 1/4,
               strict_span = true, span_buffer = nothing)

Find some reasonable values for tick marks.

This is basically Wilkinson's ad-hoc scoring method that tries to balance
tight fit around the data, optimal number of ticks, and simple numbers.

## Arguments:

*    `xmax`:

    The maximum value occurring in the data.

*    `xmin`:

    The minimum value occurring in the data.

*    `extend_ticks`:

    Determines whether to extend tick computation. Defaults to false.

*    `strict_span`:

    True if no ticks should be outside [x_min, x_max]. Defaults to true.

*    `Q`:

    A distribution of nice numbers from which labellings are sampled. Stored in the form (number, score).

*    `k_min`:

    The minimum number of ticks.

*    `k_max`:

    The maximum number of ticks.

*    `k_ideal`:

    The ideal number of ticks.

*    `granularity_weight`:

    Encourages returning roughly the number of labels requested.

*    `simplicity_weight`:

    Encourages nicer labeling sequences by preferring step sizes that appear earlier in Q.
    Also rewards labelings that include 0 as a way to ground the sequence.

*    `coverage_weight`:

    Encourages labelings that do not extend far beyond the range of the data, penalizing unnecessary whitespace.

*    `niceness_weight`:

    Encourages labellings to produce nice ranges.

## Returns:
  `(ticklocations::Vector{Float64}, x_min, x_max)`

## Mathematical details

Wilkinson’s optimization function is defined as the sum of three
components. If the user requests m labels and a possible labeling has
k labels, then the components are `simplicity`, `coverage` and `granularity`.

These components are defined as follows:
```math
\\begin{aligned}
  &\\text{simplicity} = 1 - \\frac{i}{|Q|} + \\frac{v}{|Q|}\\\\
  &\\text{coverage}   = \\frac{x_{max} - x_{min}}{\\mathrm{label}_{max} - \\mathrm{label}_{min}}\\\\
  &\\text{granularity}= 1 - \\frac{\\left|k - m\\right|}{m}
\\end{aligned}
```

and the variables here are:

*  `q`: element of `Q`.
*  `i`: index of `q` ∈ `Q`.
*  `v`: 1 if label range includes 0, 0 otherwise.
"""
function optimize_ticks(
    x_min::T,
    x_max::T;
    extend_ticks::Bool = false,
    Q = [(1.0, 1.0), (5.0, 0.9), (2.0, 0.7), (2.5, 0.5), (3.0, 0.2)],
    k_min::Integer = 2,
    k_max::Integer = 10,
    k_ideal::Integer = 5,
    granularity_weight::Float64 = 1 / 4,
    simplicity_weight::Float64 = 1 / 6,
    coverage_weight::Float64 = 1 / 3,
    niceness_weight::Float64 = 1 / 4,
    strict_span = true,
    span_buffer = nothing,
    scale = nothing,
) where {T}
    rtol = T <: AbstractFloat ? 1000.0 * eps(T) : Base.rtoldefault(x_min, x_max, 0)
    if isapprox(x_min, x_max, rtol = rtol)
        return fallback_ticks(x_min, x_max, k_min, k_max, strict_span)
    end

    F = float(T)
    Qv = F[q[1] for q ∈ Q]
    Qs = F[q[2] for q ∈ Q]

    base_float = F(get(_logScaleBases, scale, 10.0))
    base = isinteger(base_float) ? Int(base_float) : 10
    is_log_scale = scale ∈ _logScales

    for i ∈ 1:2
        sspan = i == 1 ? strict_span : false
        high_score, best, min_best, max_best = optimize_ticks_typed(
            F(x_min),
            F(x_max),
            extend_ticks,
            Qv,
            Qs,
            k_min,
            k_max,
            k_ideal,
            F(granularity_weight),
            F(simplicity_weight),
            F(coverage_weight),
            F(niceness_weight),
            sspan,
            span_buffer,
            is_log_scale,
            base_float,
            base,
        )

        if isinf(high_score)
            if sspan
                @warn "No strict ticks found"
            else
                return fallback_ticks(x_min, x_max, k_min, k_max, strict_span)
            end
        else
            return best, min_best, max_best
        end
    end
end

function optimize_ticks_typed(
    x_min::F,
    x_max::F,
    extend_ticks,
    Qv,
    Qs,
    k_min,
    k_max,
    k_ideal,
    granularity_weight::F,
    simplicity_weight::F,
    coverage_weight::F,
    niceness_weight::F,
    strict_span,
    span_buffer,
    is_log_scale,
    base_float::F,
    base::Integer,
) where {F<:AbstractFloat}
    xspan = x_max - x_min

    # generalizing "order of magnitude"
    z = bounding_order_of_magnitude(xspan, base_float)

    # find required significant digits for ticks with q * base^z spacing,
    # for q values specified in Qv
    num_digits = (
        bounding_order_of_magnitude(max(abs(x_min), abs(x_max)), base_float) +
        maximum(postdecimal_digits(q) for q ∈ Qv)
    )

    viewmin_best, viewmax_best = x_min, x_max
    high_score = -Inf

    S_best = Vector{F}(undef, k_max)
    len_S_best = length(S_best)

    S = Vector{F}(undef, (extend_ticks ? 4 : 2) * k_max)

    @inbounds begin
        while 2k_max * base_float^(z + 1) > xspan
            sigdigits = max(1, num_digits - z)
            for k ∈ k_min:(2k_max)
                for (q, qscore) ∈ zip(Qv, Qs)
                    tickspan = q * base_float^z
                    tickspan < eps(F) && continue
                    span = (k - 1) * tickspan
                    span < xspan && continue

                    r_float = (x_max - span) / tickspan
                    isfinite(r_float) || continue
                    r = ceil(Int, r_float)

                    # try to favor integer exponents for log scales
                    (nice_scale = !is_log_scale || isinteger(tickspan)) || (qscore = F(0))

                    while r * tickspan ≤ x_min
                        # Filter or expand ticks
                        if extend_ticks
                            for i ∈ 0:(3k - 1)
                                S[i + 1] = (r + i - k) * tickspan
                            end
                            imin = k + 1
                            imax = 2k
                        else
                            for i ∈ 0:(k - 1)
                                S[i + 1] = (r + i) * tickspan
                            end
                            imin = 1
                            imax = k
                        end
                        # round only those values that end up as viewmin and viewmax to save computation time
                        S[imin] =
                            viewmin = round(S[imin], sigdigits = sigdigits, base = base)
                        S[imax] =
                            viewmax = round(S[imax], sigdigits = sigdigits, base = base)

                        if strict_span
                            viewmin = max(viewmin, x_min)
                            viewmax = min(viewmax, x_max)
                            buf = something(span_buffer, 0) * (viewmax - viewmin)

                            # filter the S array while reusing its own memory to do so
                            # this works because S is sorted, and we will only overwrite
                            # values that are not needed anymore going forward in the loop

                            # we do this because it saves allocations and leaves S type stable
                            counter = 0
                            for i ∈ 1:imax
                                if (viewmin - buf) ≤ S[i] ≤ (viewmax + buf)
                                    counter += 1
                                    S[counter] = S[i]
                                end
                            end
                            len = counter
                        else
                            len = imax
                        end

                        # evaluate quality of ticks
                        has_zero = r ≤ 0 && abs(r) < k

                        # simplicity
                        s = has_zero && nice_scale ? 1 : 0

                        # granularity
                        g = 0 < len < 2k_ideal ? 1 - abs(len - k_ideal) / k_ideal : F(0)

                        # coverage
                        c = if len > 1
                            effective_span = (len - 1) * tickspan
                            1.5xspan / effective_span
                        else
                            F(0)
                        end

                        score =
                            granularity_weight * g +
                            simplicity_weight * s +
                            coverage_weight * c +
                            niceness_weight * qscore

                        # strict limits on coverage
                        if strict_span && span > xspan
                            score -= 10000
                        end
                        if span ≥ 2xspan
                            score -= 1000
                        end

                        if score > high_score && (k_min ≤ len ≤ k_max)
                            viewmin_best, viewmax_best = viewmin, viewmax
                            high_score, len_S_best = score, len
                            copyto!(S_best, view(S, 1:len))
                        end
                        r += 1
                    end
                end
            end
            z -= 1
        end
    end
    resize!(S_best, len_S_best)
    return high_score, S_best, viewmin_best, viewmax_best
end

optimize_ticks(
    x_min::Date,
    x_max::Date;
    extend_ticks::Bool = false,
    k_min = nothing,
    k_max = nothing,
    scale = :auto,
    granularity_weight = nothing,
    simplicity_weight = nothing,
    coverage_weight = nothing,
    niceness_weight = nothing,
    strict_span = true,
    span_buffer = nothing,
) = optimize_ticks(
    convert(DateTime, x_min),
    convert(DateTime, x_max),
    extend_ticks = extend_ticks,
    scale = scale,
)

function optimize_ticks(
    x_min::DateTime,
    x_max::DateTime;
    extend_ticks::Bool = false,
    k_min = nothing,
    k_max = nothing,
    scale = :auto,
    granularity_weight = nothing,
    simplicity_weight = nothing,
    coverage_weight = nothing,
    niceness_weight = nothing,
    strict_span = true,
    span_buffer = nothing,
)
    if x_min == x_max
        x_max += Second(1)
    end

    if year(x_max) - year(x_min) ≤ 1 && scale ≢ :year
        if year(x_max) == year(x_min) && month(x_max) - month(x_min) ≤ 1 && scale ≢ :month
            ticks = DateTime[]

            scales = [
                Day(1),
                Hour(1),
                Minute(1),
                Second(1),
                Millisecond(100),
                Millisecond(10),
                Millisecond(1),
            ]

            # ticks on week boundaries
            if x_min + Day(7) < x_max || scale ≡ :week
                push!(ticks, x_min)
                while true
                    next_month = Date(year(ticks[end]), month(ticks[end])) + Month(1)
                    while ticks[end] + Week(1) < next_month - Day(2)
                        push!(ticks, ticks[end] + Week(1))
                    end
                    push!(ticks, next_month)
                    if next_month ≥ x_max
                        break
                    end
                end
            else
                scale = nothing
                if scale ≢ :auto
                    # TODO: manually setting scale with :day, :minute, etc
                end

                if scale ≡ nothing
                    for proposed_scale ∈ [
                        Day(1),
                        Hour(1),
                        Minute(1),
                        Second(1),
                        Millisecond(100),
                        Millisecond(10),
                        Millisecond(1),
                    ]
                        if x_min + proposed_scale < x_max
                            scale = proposed_scale
                            break
                        end
                    end
                end

                if scale ≡ nothing
                    scale = Millisecond(1)
                end

                # round x_min down
                first_tick = if scale ≡ Day(1)
                    DateTime(year(x_min), month(x_min), day(x_min))
                elseif scale ≡ Hour(1)
                    DateTime(year(x_min), month(x_min), day(x_min), hour(x_min))
                elseif scale ≡ Minute(1)
                    DateTime(year(x_min), month(x_min), day(x_min), hour(x_min), minute(x_min))
                elseif scale ≡ Second(1)
                    DateTime(
                        year(x_min),
                        month(x_min),
                        day(x_min),
                        hour(x_min),
                        minute(x_min),
                        second(x_min),
                    )
                elseif scale ≡ Millisecond(100)
                    DateTime(
                        year(x_min),
                        month(x_min),
                        day(x_min),
                        hour(x_min),
                        minute(x_min),
                        second(x_min),
                        millisecond(x_min) % 100,
                    )
                elseif scale ≡ Millisecond(10)
                    DateTime(
                        year(x_min),
                        month(x_min),
                        day(x_min),
                        hour(x_min),
                        minute(x_min),
                        second(x_min),
                        millisecond(x_min) % 10,
                    )
                else
                    x_min
                end
                push!(ticks, first_tick)

                while ticks[end] < x_max
                    push!(ticks, ticks[end] + scale)
                end
            end

            viewmin, viewmax = ticks[1], ticks[end]
            return ticks, viewmin, viewmax
        else
            ticks = DateTime[]
            push!(ticks, Date(year(x_min), month(x_min)))
            while ticks[end] < x_max
                push!(ticks, ticks[end] + Month(1))
            end
            viewmin, viewmax = ticks[1], ticks[end]

            return ticks, x_min, x_max
        end
    else
        ticks, viewmin, viewmax = optimize_ticks(
            year(x_min),
            year(x_max + Year(1) - Day(1)),
            extend_ticks = extend_ticks,
        )

        return DateTime[DateTime(round(y)) for y ∈ ticks],
        DateTime(round(viewmin)),
        DateTime(round(viewmax))
    end
end

# Generate ticks suitable for multiple scales.
function multilevel_ticks(viewmin::T, viewmax::T; scales = [0.5, 5.0, 10.0]) where {T}
    ticks = Dict()
    for scale ∈ scales
        ticks[scale] = optimize_ticks(
            viewmin,
            viewmax,
            k_min = max(1, round(Int, 2scale)),
            k_max = max(3, round(Int, 10scale)),
            k_ideal = max(2, round(Int, 15scale)),
        )[1]
    end
    return ticks
end

multilevel_ticks(viewmin::Date, viewmax::Date; scales = [:year, :month, :day]) =
    multilevel_ticks(
        convert(DateTime, viewmin),
        convert(DateTime, viewmax),
        scales = scales,
    )

function multilevel_ticks(
    viewmin::DateTime,
    viewmax::DateTime;
    scales = [:year, :month, :day],
)
    # TODO: This needs to be improved for DateTime
    span = convert(Float64, Dates.toms(viewmax - viewmin))
    ticks = Dict()
    for scale ∈ scales
        s = if scale ≡ :year
            span / Dates.toms(Day(360))
        elseif scale ≡ :month
            span / Dates.toms(Day(90))
        else
            span / Dates.toms(Day(1))
        end

        ticks[s / 20] = optimize_ticks(viewmin, viewmax, scale = scale)[1]
    end

    return ticks
end

# Choose "round" (full seconds/minutes/hours/days/months/years) DateTime ticks
# between x_min and x_max:
function optimize_datetime_ticks(a_min, a_max; k_min = 2, k_max = 4)
    # Int64 is needed here for 32bit systems
    x_min = DateTime(Dates.UTM(Int64(round(a_min))))
    x_max = DateTime(Dates.UTM(Int64(round(a_max))))

    Δt = x_max - x_min
    if Δt > Dates.Day(365k_min)
        P = Dates.Year
        steplength = Δt / (k_max * Dates.Millisecond(Dates.Day(365)))
    elseif Δt > Dates.Day(30k_min)
        P = Dates.Month
        steplength = Δt / (k_max * Dates.Millisecond(Dates.Day(30)))
    elseif Δt > Dates.Day(k_min)
        P = Dates.Day
        steplength = Δt / (k_max * Dates.Millisecond(Dates.Day(1)))
    elseif Δt > Dates.Hour(k_min)
        P = Dates.Hour
        steplength = Δt / (k_max * Dates.Millisecond(Dates.Hour(1)))
    elseif Δt > Dates.Minute(k_min)
        P = Dates.Minute
        steplength = Δt / (k_max * Dates.Millisecond(Dates.Minute(1)))
    elseif Δt > Dates.Second(k_min)
        P = Dates.Second
        steplength = Δt / (k_max * Dates.Millisecond(Dates.Second(1)))
    else
        P = Dates.Millisecond
        steplength = Δt / (k_max * Dates.Millisecond(1))
    end
    steplength = P(max(1, Int(round(steplength))))

    period_hierarchy = [
        Dates.Millisecond,
        Dates.Second,
        Dates.Minute,
        Dates.Hour,
        Dates.Day,
        Dates.Month,
        Dates.Year,
    ]
    i = findfirst(period_hierarchy .== P)
    showtype = i ≥ 5 ? Date : DateTime
    start = DateTime((PH(x_min) for PH ∈ period_hierarchy[end:-1:i])...) + P(1)
    ticks = collect(start:steplength:x_max)
    labels = string.(showtype.(ticks))

    return Dates.value.(ticks), labels
end

#=
This file contains code for calculating intervals for plotting purposes.
These functions should, at minimum, take in some form of data input and
return a tuple (min, max) of the limits corresponding to the function
=#

using Statistics: mean, median, std

"""
    zscale(input::AbstractArray,
        nsamples=1000;
        contrast=0.25,
        max_reject=0.5,
        min_npixels=5,
        k_rej=2.5,
        max_iterations=5)

Implementation of the `zscale` IRAF function for finding
colorbar limits of `input`, which showcase data near the median.
This is useful for data with extreme outliers, such as astronomical images.


## Keyword arguments
* `nsamples` - The number of samples to use from `input`. If fewer than `nsamples` are present, will use the full input
* `contrast` - The desired contrast
* `k_rej` - The number of standard deviations above which data is rejected
* `max_iteration` - The number of iterations used for fitting samples
* `max_reject` - The maximum number of pixels to reject during the iterative fitting
* `min_npixels` - The minimum number of pixels to calculate the limits after the iterative fitting

See the extended help (in REPL, `??zscale`) for technical details.

## Examples
```jldoctest
julia> img = 0:9999

julia> zscale(img)
(0, 9990)
```

## Extended help
## Description

The zscale algorithm is designed to display the image values
near the median image value, without the time consuming process
of computing a full image histogram.

This is particularly useful for astronomical images, which generally
have a very peaked histogram corresponding to the background sky
in direct imaging, or the continuum in a two dimensional spectrum.

A subset of the image is examined, and approximately `nsamples`
pixels are sampled evenly over the image. The number of lines is a
user parameter, `nsample_lines`.

The pixels are ranked in brightness to form the function `I(i)`,
where `i` is the rank of the pixel, and `I` is its value. Generally,
the midpoint of this function (the median) is very near the peak
of the image histogram.  There is a well defined slope about the
midpoint, which is related to the width of the histogram.

At the ends of the `I(i)` function, there are a few very bright and
dark pixels due to objects and defects in the field. To determine
the slope, a linear function is fit with iterative rejection:

```
I(i) = intercept + slope * (i - midpoint)
```

If more than half of the points are rejected, then there is no well
defined slope, and the full range of the sample defines `z1` and
`z2`. Otherwise, the endpoints of the linear function are used
(provided they are within the original range of the sample):

```
z1 = I(midpoint) + (slope / contrast) * (1 - midpoint)
z2 = I(midpoint) + (slope / contrast) * (npoints - midpoint)
```
"""
function zscale(
        input::AbstractArray,
        nsamples::Int = 1000;
        contrast = 0.25,
        max_reject = 0.5,
        min_npixels = 5,
        k_rej = 2.5,
        max_iterations = 5,
    )

    # get samples from finite values of input
    values = float(filter(isfinite, input))
    stride = max(1, round(Int, length(values) / nsamples))
    samples = @view values[1:stride:end][1:min(nsamples, end)]
    sort!(samples)

    N = length(samples)
    vmin = first(samples)
    vmax = last(samples)

    # fit a line to the sorted samples
    min_pix = max(min_npixels, round(Int, N * max_reject))
    x = 0:(N - 1)

    ngood = N
    last_good = N + 1

    # good pixel mask (array bool faster than bitarray)
    mask = ones(Bool, N)

    # get number of neighbors to mask if a pixel is bad
    ngrow = max(1, round(Int, N / 100) ÷ 2)

    local β # line slope
    # iteratively fit samples and reject sigma-clipped outliers
    for _ in 1:max_iterations
        (ngood ≥ last_good || ngood < min_pix) && break

        # linear fit using mask
        x_ = @view x[mask]
        y = @view samples[mask]
        α, β = fit_line(x_, y)
        flat = @. samples - (α + β * x)

        # k-sigma rejection threshold
        threshold = k_rej * std(flat[mask])

        # detect and reject outliers based on threshold
        @. mask[!(-threshold ≤ flat ≤ threshold)] = false

        # dilate mask
        mask = dilate_mask(mask, ngrow)

        last_good = ngood
        ngood = count(mask)
    end

    if ngood ≥ min_pix
        slope = contrast > 0 ? β / contrast : β
        center = (N - 1) ÷ 2
        m = median(samples)
        vmin = max(vmin, m - (center - 1) * slope)
        vmax = min(vmax, m + (N - center) * slope)
    end

    return vmin, vmax
end

"""
    dilate_mask(mask, ngrow)

Takes a mask and dilates each `false` with `ngrow` `false`s on
either side.  This is equivalent to boolean "convolution".
"""
function dilate_mask(mask, ngrow)
    out = similar(mask)
    idxs = CartesianIndices(mask)
    mindx = idxs[1].I[1]
    maxdx = idxs[end].I[1]
    @inbounds for idx in idxs
        lower = max(mindx, idx.I[1] - ngrow)
        upper = min(maxdx, idx.I[1] + ngrow)
        # output will only be true if there are no falses in the input section
        out[idx] = all(mask[lower:upper])
    end
    return out
end

"""
    fit_line(x, y)

Simple linear regression, returns `(intercept, slope)`.
https://en.wikipedia.org/wiki/Simple_linear_regression
"""
function fit_line(x, y)
    mx = mean(x)
    my = mean(y)
    SSxy = sum(zip(x, y)) do (xi, yi)
        (xi - mx) * (yi - my)
    end
    SSx = sum(x) do xi
        (xi - mx)^2
    end
    β = SSxy / SSx
    α = my - β * mx
    return α, β
end

# An abstract color list is either a Palette or a gradient
abstract type AbstractColorList end

get_colorscheme(acl::AbstractColorList) = acl.colors
color_list(acl::AbstractColorList) = color_list(acl.colors)
plot_color(cl::AbstractColorList) = cl

# Interface
Base.show(io::IO, m::MIME"image/svg+xml", acl::AbstractColorList) =
    show(io, m, color_list(acl))
Base.length(acl::AbstractColorList) = length(color_list(acl))
Base.getindex(acl::AbstractColorList, x) = getindex(color_list(acl), x)
Base.size(acl::AbstractColorList) = size(color_list(acl))
Base.IndexStyle(::Type{<:AbstractColorList}) = IndexLinear()
Base.iterate(acl::AbstractColorList) = iterate(color_list(acl))
Base.iterate(acl::AbstractColorList, s) = iterate(color_list(acl), s)
Base.lastindex(acl::AbstractColorList) = lastindex(color_list(acl))
Base.firstindex(acl::AbstractColorList) = firstindex(color_list(acl))
Base.get(acl::AbstractColorList, args...) = get(get_colorscheme(acl), args...)

## ColorGradient

abstract type ColorGradient <: AbstractColorList end

Base.getindex(cg::ColorGradient, x::Union{AbstractFloat,AbstractVector{<:AbstractFloat}}) =
    get(cg, x)
function Base.get(cg::ColorGradient, v::AbstractArray, rangescale = (0.0, 1.0))
    rangescale ≡ :extrema && (rangescale = extrema(v))
    map(x -> get(cg, x, rangescale), v)
end

Base.:(==)(cg1::ColorGradient, cg2::ColorGradient) =
    color_list(cg1) == color_list(cg2) && cg1.values == cg2.values
Base.hash(cg::ColorGradient) = hash(color_list(cg)) ⊻ hash(cg.values)

## Continuous Color Gradient

struct ContinuousColorGradient <: ColorGradient
    colors::ColorScheme
    values::Vector{Float64}

    function ContinuousColorGradient(colors, values = get_range(colors))
        c, v = prepare_continuous_cgrad_colors(colors, values)
        new(c, v)
    end
end

plot_color(cg::ContinuousColorGradient, α::Number) =
    ContinuousColorGradient(plot_color(cg.colors, α), cg.values)

Base.show(io::IO, m::MIME"image/svg+xml", cg::ContinuousColorGradient) =
    show(io, m, cg[get_range(100)])

function sample_color(cg::ContinuousColorGradient, x::AbstractFloat)
    c, v = cg.colors, cg.values
    if (index = findfirst(==(x), v)) ≡ nothing
        nm1 = length(v) - 1
        i = min(nm1, findlast(<(x), v))
        r = (x - v[i]) / (v[i + 1] - v[i])
        index = (i + r - 1) / nm1
    end
    c[index]
end

function Base.get(cg::ContinuousColorGradient, x::AbstractFloat, rangescale = (0.0, 1.0))
    isfinite(x) || return invisible()
    rangescale = get_rangescale(rangescale)
    allunique(rangescale) || return first(cg.colors)
    x = clamp(x, rangescale...)
    if rangescale != (0.0, 1.0)
        x = ColorSchemes.remap(x, rangescale..., 0, 1)
    end
    sample_color(cg, x)  # specialize for x (boxing issues ?)
end

Base.reverse(cg::ContinuousColorGradient) =
    ContinuousColorGradient(reverse(cg.colors), reverse(1 .- cg.values))

# required for GR's nonuniformcellarray
function ColorSchemes.getinverse(cg::ContinuousColorGradient, c)
    alpha(c) == 0 && return NaN
    z = getinverse(to_rgb(get_colorscheme(cg)), to_rgb(c))
    cr = get_range(cg.colors)
    if (index = findfirst(==(z), cr)) ≢ nothing
        cg.values[index]
    else
        i = min(length(cr) - 1, findlast(<(z), cr))
        ColorSchemes.remap(z, cr[i], cr[i + 1], cg.values[i], cg.values[i + 1])
    end
end

function prepare_continuous_cgrad_colors(c, v)
    v = sort(unique(clamp.(v, 0, 1)))
    0 ∈ v || pushfirst!(v, 0)
    1 ∈ v || push!(v, 1)
    nv = length(v)
    nc = length(c)
    c, v = if nc != nv
        value_range = get_range(nv)
        color_range = get_range(nc)
        values = [0.0]
        for i ∈ 2:nv
            inds = findall(x -> value_range[i - 1] < x < value_range[i], color_range)
            isempty(inds) || append!(
                values,
                ColorSchemes.remap(
                    color_range[inds],
                    value_range[i - 1],
                    value_range[i],
                    v[i - 1],
                    v[i],
                ),
            )
            push!(values, v[i])
        end
        colors = c[sort(unique([value_range; color_range]))]
        colors, values
    else
        color_list(c), v
    end
    ColorScheme(plot_color(c)), v
end

## Categorical Color Gradient

struct CategoricalColorGradient <: ColorGradient
    colors::ColorScheme
    values::Vector{Float64}

    function CategoricalColorGradient(colors, values = get_range(colors))
        c, v = prepare_categorical_cgrad_colors(colors, values)
        new(c, v)
    end
end

plot_color(cg::CategoricalColorGradient, α::Number) =
    CategoricalColorGradient(plot_color(cg.colors, α), cg.values)

Base.show(io::IO, m::MIME"image/svg+xml", cg::CategoricalColorGradient) =
    show(io, m, cg[get_range(100)])

function Base.get(cg::CategoricalColorGradient, x::AbstractFloat, rangescale = (0.0, 1.0))
    isfinite(x) || return invisible()
    rangescale = get_rangescale(rangescale)
    x = clamp.(x, rangescale...)
    if rangescale != (0.0, 1.0)
        x = ColorSchemes.remap(x, rangescale..., 0, 1)
    end
    cg.colors[x == 0 ? 1 : findlast(<(x), cg.values)]
end

Base.reverse(cg::CategoricalColorGradient) =
    CategoricalColorGradient(reverse(cg.colors), reverse(1 .- cg.values))

# required for GR's nonuniformcellarray
function ColorSchemes.getinverse(cg::CategoricalColorGradient, c)
    alpha(c) == 0 && return NaN
    i = findfirst(==(c), color_list(cg))
    (cg.values[i] + cg.values[i + 1]) / 2
end

function prepare_categorical_cgrad_colors(c, v)
    v = sort(unique(clamp.(v, 0, 1)))
    0 ∈ v || pushfirst!(v, 0)
    1 ∈ v || push!(v, 1)
    colors = map(c[get_range(length(v) - 1)]) do col
        RGBA(RGB(col), clamp(alpha(col), 0, 1))
    end
    ColorScheme(plot_color(colors)), v
end

## cgrad

"""
    cgrad(colors, [values]; categorical = nothing, scale = nothing, rev = false, alpha = nothing)

Construct a Colorgradient from `colors` and `values`.

`colors` can be a symbol for ColorSchemes.jl `ColorScheme`s, a `ColorScheme`, a vector of colors, a `ColorGradient` or a `ColorPalette`.
If `values` is an integer, it specifies the numbers of colors chosen equidistantly from the colorscheme specified by colors.
Otherwise vectors are accepted.
For continuous color gradients `values` indicate where between 0 and 1 the colors are positioned.
For categorical color gradients `values` indicate where a color ends and where a new one begins between 0 and 1.
0 and 1 are added to `values` if not already present.

If `rev` is `true` colors are reversed.
`scale` accepts the symbols `:log`, `:log10`, `:log2`, `:ln`, `:exp`, `:exp10` or functions.
If `alpha` is set, it is applied to all colors.
"""
function cgrad(
    colors::ColorScheme,
    values;
    categorical::Union{Nothing,Bool} = nothing,
    scale = nothing,
    rev = false,
    alpha = nothing,
)
    if categorical ≢ nothing && categorical
        colors, values = prepare_categorical_cgrad_colors(colors, values)
    end

    if alpha ≢ nothing
        rgbs = convert.(RGB, colors.colors)
        colors = ColorScheme(RGBA.(rgbs, alpha))
    end
    rev && (colors = reverse(colors))
    values = if scale ∈ (:log, :log10) || scale ≡ log10
        log10.(ColorSchemes.remap(values, 0, 1, 1, 10))
    elseif scale ≡ :log2 || scale ≡ log2
        log2.(ColorSchemes.remap(values, 0, 1, 1, 2))
    elseif scale ≡ :ln || scale ≡ log
        log.(ColorSchemes.remap(values, 0, 1, 1, ℯ))
    elseif scale ∈ (:exp, :exp10) || scale ≡ exp10 || scale ≡ exp
        ColorSchemes.remap(exp10.(values), 1, 10, 0, 1)
    elseif scale isa Function
        v = scale.(values)
        ColorSchemes.remap(v, extrema(v)..., 0, 1)
    else
        values
    end

    if categorical ≢ nothing && categorical
        CategoricalColorGradient(colors, values)
    else
        ContinuousColorGradient(colors, values)
    end
end

function cgrad(
    colors::ColorScheme,
    n::Int = length(colors);
    categorical = nothing,
    kwargs...,
)
    values = get_range(n + (categorical ≢ nothing))
    cgrad(colors, values; categorical = categorical, kwargs...)
end

function cgrad(colors, args...; kwargs...)
    colors ≡ :default && (colors = :inferno)
    cgrad(get_colorscheme(colors), args...; kwargs...)
end

cgrad(; kw...) = cgrad(DEFAULT_COLOR_GRADIENT[]; kw...)

default_cgrad(cg; kw...) = DEFAULT_COLOR_GRADIENT[] = cgrad(cg; kw...)

function get_rangescale(rangescale)
    rangescale ≡ :clamp && return (0.0, 1.0)
    rangescale ≡ :extrema && return extrema(x)
    (rangescale isa NTuple{2,Number}) || error(
        "rangescale ($rangescale) not supported, should be :clamp, :extrema or tuple (minVal, maxVal).  Got $(rangescale).",
    )
    rangescale
end

## ColorPalette

struct ColorPalette <: AbstractColorList
    colors::ColorScheme
end

plot_color(cp::ColorPalette, α::Number) = palette(cp, alpha = α)

Base.reverse(cp::ColorPalette) = ColorPalette(reverse(cp.colors))

"""
    palette(colors, [n]; rev = false, alpha = nothing)

Construct a `ColorPalette`.
Accepts symbols for Colorschemes.jl `ColorScheme`s, `ColorScheme`s, vectors of colors, `ColorGradient`s and `ColorPalettes`.
If 'n' is provided, `n` colors are chosen equidistantly from the colorscheme.
If `rev` is `true` colors are reversed.
"""
function palette(cs; rev = false, alpha = nothing)
    cs = get_colorscheme(cs)
    if alpha ≢ nothing
        rgbs = convert.(RGB, cs.colors)
        cs = ColorScheme(RGBA.(rgbs, alpha))
    end
    rev && (cs = reverse(cs))
    ColorPalette(cs)
end

function palette(cs, n; kwargs...)
    cs = get_colorscheme(cs)
    z = get_range(n)
    palette(cs[z]; kwargs...)
end

## Utils

get_range(n::Int) = range(0, stop = n == 1 ? 0 : 1, length = n)
get_range(cs) = get_range(length(cs))

get_colorscheme(v::AbstractVector{<:Colorant}) = ColorScheme(v)
get_colorscheme(v::AbstractVector) = ColorScheme(parse.(Colorant, v))
function get_colorscheme(sym::Symbol)
    haskey(MISC_COLORSCHEMES, sym) && return MISC_COLORSCHEMES[sym]
    sym = get(COLORSCHEME_ALIASES, sym, sym)
    if sym ≡ :default || sym ≡ :auto
        _default_colorscheme
    elseif haskey(ColorSchemes.colorschemes, sym)
        ColorSchemes.colorschemes[sym]
    else
        error(
            "Unknown ColorScheme `:$sym`. Check https://juliagraphics.github.io/ColorSchemes.jl/stable/ for available ColorSchemes.",
        )
    end
end
get_colorscheme(cs::ColorScheme) = cs

function cvec(cs, n = 10; kw...)
    cg = cgrad(cs; kw...)
    RGBA{Float64}[cg[z] for z ∈ get_range(n)]
end

color_list(c) = get_colorscheme(c).colors
color_list(v::AbstractVector) = plot_color.(v)

get_color_palette(v, n) = palette(v)
get_color_palette(cg::ColorGradient, n) = palette(cg[get_zvalues(n)])

to_rgb(c::Colorant) = RGB(c)
to_rgb(cs::ColorScheme) = ColorScheme(to_rgb.(cs.colors))
to_rgb(cg::ColorGradient) = ColorGradient(to_rgb(cg.colors))
to_rgb(cp::ColorPalette) = ColorPalette(to_rgb(cp.colors))

# allows passing a ColorGradient to rgba_string and get a useful response by picking the first color - introduced because the plotly backend to Plots uses this functionality
rgba_string(cg::T) where {T<:Union{ColorScheme,ColorGradient,ColorPalette}} =
    rgba_string(cg[1])

is_colorscheme(sym) =
    sym ∈ keys(ColorSchemes.colorschemes) ||
    sym ∈ keys(COLORSCHEME_ALIASES) ||
    sym ∈ keys(MISC_COLORSCHEMES)

const DEFAULT_COLOR_GRADIENT = Ref(cgrad(ColorSchemes.colorschemes[:inferno]))

## Compat

const COLORSCHEME_ALIASES = Dict{Symbol,Symbol}(
    # colorbrewer
    :Spectral => :Spectral_11,
    :RdYlGn => :RdYlGn_11,
    :RdBu => :RdBu_11,
    :PiYG => :PiYG_11,
    :PRGn => :PRGn_11,
    :RdYlBu => :RdYlBu_11,
    :BrBG => :BrBG_11,
    :RdGy => :RdGy_11,
    :Set2 => :Set2_8,
    :Accent => :Accent_8,
    :Set1 => :Set1_9,
    :Set3 => :Set3_12,
    :Dark2 => :Dark2_8,
    :Paired => :Paired_12,
    :Pastel2 => :Pastel2_8,
    :Pastel1 => :Pastel1_9,
    :PuOr => :PuOr_11,
    :OrRd => :OrRd_9,
    :PuBu => :PuBu_9,
    :BuPu => :BuPu_9,
    :Oranges => :Oranges_9,
    :BuGn => :BuGn_9,
    :YlOrBr => :YlOrBr_9,
    :YlGn => :YlGn_9,
    :Reds => :Reds_9,
    :RdPu => :RdPu_9,
    :Greens => :Greens_9,
    :YlGnBu => :YlGnBu_9,
    :Purples => :Purples_9,
    :GnBu => :GnBu_9,
    :Greys => :Greys_9,
    :YlOrRd => :YlOrRd_8,
    :PuRd => :PuRd_9,
    :Blues => :Blues_9,
    :PuBuGn => :PuBuGn_9,
    # colorcet
    :bgy => :linear_bgy_10_95_c74_n256,
    :bgyw => :linear_bgyw_15_100_c68_n256,
    :bjy => :diverging_linear_bjy_30_90_c45_n256,
    :bkr => :diverging_bkr_55_10_c35_n256,
    :bky => :diverging_bky_60_10_c30_n256,
    :blues => :linear_blue_5_95_c73_n256,
    :bmw => :linear_bmw_5_95_c86_n256,
    :colorwheel => :cyclic_mygbm_30_95_c78_n256_s25,
    :dimgreys => :linear_grey_10_95_c0_n256,
    :fire => :linear_kryw_0_100_c71_n256,
    :greys => :linear_grey_0_100_c0_n256,
    :gwv => :diverging_gwv_55_95_c39_n256,
    :cinferno => :linear_bmy_10_95_c78_n256,
    :isolum => :isoluminant_cgo_80_c38_n256,
    :kb => :linear_ternary_blue_0_44_c57_n256,
    :kdc => :linear_blue_5_95_c73_n256,
    :kg => :linear_ternary_green_0_46_c42_n256,
    :kgy => :linear_green_5_95_c69_n256,
    :kr => :linear_ternary_red_0_50_c52_n256,
    :diverging => :diverging_bwr_40_95_c42_n256,
    :cyclic1 => :cyclic_mrybm_35_75_c68_n256,
    :cyclic2 => :cyclic_mygbm_30_95_c78_n256,
    :cyclic3 => :cyclic_wrwbw_40_90_c42_n256,
)

## Plots misc colorschemes

const RAINBOW_COLORS = RGBA{Float64}[
    colorant"purple",
    colorant"blue",
    colorant"green",
    colorant"orange",
    colorant"red",
]
const TEST_COLORS = RGBA{Float64}[
    colorant"darkblue",
    colorant"blueviolet",
    colorant"darkcyan",
    colorant"green",
    darken(colorant"yellow", 0.3),
    colorant"orange",
    darken(colorant"red", 0.2),
]

const MISC_COLORSCHEMES = Dict{Symbol,ColorScheme}(
    :blues => ColorScheme(RGBA{Float64}[colorant"lightblue", colorant"darkblue"]),
    :reds => ColorScheme(RGBA{Float64}[colorant"lightpink", colorant"darkred"]),
    :greens => ColorScheme(RGBA{Float64}[colorant"lightgreen", colorant"darkgreen"]),
    :redsblues => ColorScheme(
        RGBA{Float64}[colorant"darkred", RGB(0.8, 0.85, 0.8), colorant"darkblue"],
    ),
    :bluesreds => ColorScheme(
        RGBA{Float64}[colorant"darkblue", RGB(0.8, 0.85, 0.8), colorant"darkred"],
    ),
    :heat => ColorScheme(
        RGBA{Float64}[colorant"lightyellow", colorant"orange", colorant"darkred"],
    ),
    :grays => ColorScheme(RGBA{Float64}[RGB(0.05, 0.05, 0.05), RGB(0.95, 0.95, 0.95)]),
    :rainbow => ColorScheme(RAINBOW_COLORS),
    :lightrainbow => ColorScheme(map(lighten, RAINBOW_COLORS)),
    :darkrainbow => ColorScheme(map(darken, RAINBOW_COLORS)),
    :darktest => ColorScheme(TEST_COLORS),
    :lighttest => ColorScheme(map(c -> lighten(c, 0.3), TEST_COLORS)),
)

"""
    adapted_grid(f, minmax::Tuple{Number, Number}; max_recursions = 7, max_curvature = 0.01, n_points = 31)

Computes a grid `x` on the interval [minmax[1], minmax[2]] so that `plot(f, x)` gives a smooth "nice" plot.
The method used is to create an uniform grid with `n_points` initial points and refine intervals
where the second derivative is approximated to be large.
When an interval becomes "straight enough" it is no longer divided.
Functions are evaluated at the end points of the intervals.

The parameter `max_recursions` computes how many times each interval is allowed to be refined
while `max_curvature` specifies below which value of the curvature an interval does not need to be refined further.
"""
function adapted_grid(
        @nospecialize(f),
        minmax::Tuple{Number, Number};
        max_recursions = 7,
        max_curvature = 0.01,
        n_points = 31,
    )
    if minmax[1] > minmax[2]
        throw(ArgumentError("interval must be given as (min, max)"))
    elseif minmax[1] == minmax[2]
        x = minmax[1]
        return [x], [f(x)]
    end

    @assert isodd(n_points)
    n_intervals = n_points ÷ 2

    xs = collect(range(minmax[1]; stop = minmax[2], length = n_points))
    # Move the first and last interior points a bit closer to the end points
    xs[2] = xs[1] + (xs[2] - xs[1]) / 4
    xs[end - 1] = xs[end] - (xs[end] - xs[end - 1]) / 4

    # Wiggle interior points a bit to prevent aliasing and other degenerate cases
    rng = StableRNG(1337)
    rand_factor = 0.05
    for i in 2:(length(xs) - 1)
        xs[i] += 2rand_factor * (rand(rng) - 0.5) * (xs[i + 1] - xs[i - 1])
    end

    n_tot_refinements = zeros(Int, n_intervals)

    # Replace DomainErrors with NaNs
    g = x -> begin
        local y
        try
            y = f(x)
        catch err
            if err isa DomainError
                y = NaN
            else
                rethrow(err)
            end
        end
        return y
    end
    # We evaluate the function on the whole interval
    fs = g.(xs)
    while true
        curvatures = zeros(n_intervals)
        active = falses(n_intervals)
        isfinite_f = isfinite.(fs)
        min_f, max_f = any(isfinite_f) ? extrema(fs[isfinite_f]) : (0.0, 0.0)
        f_range = max_f - min_f
        # Guard against division by zero later
        (f_range == 0 || !isfinite(f_range)) && (f_range = one(f_range))
        # Skip first and last interval
        for interval in 1:n_intervals
            p = 2interval
            if n_tot_refinements[interval] ≥ max_recursions
                # Skip intervals that have been refined too much
                active[interval] = false
            elseif !all(isfinite.(fs[[p - 1, p, p + 1]]))
                active[interval] = true
            else
                tot_w = 0.0
                # Do a small convolution
                for (q, w) in ((-1, 0.25), (0, 0.5), (1, 0.25))
                    interval == 1 && q == -1 && continue
                    interval == n_intervals && q == 1 && continue
                    tot_w += w
                    i = p + q
                    # Estimate integral of second derivative over interval, use that as a refinement indicator
                    # https://mathformeremortals.wordpress.com/2013/01/12/a-numerical-second-derivative-from-three-points/
                    δx = xs[i + 1] - xs[i - 1]
                    curvatures[interval] +=
                        abs(
                        2(
                            (fs[i + 1] - fs[i]) / ((xs[i + 1] - xs[i]) * δx) -
                                (fs[i] - fs[i - 1]) / ((xs[i] - xs[i - 1]) * δx)
                        ) * δx^2,
                    ) / f_range * w
                end
                curvatures[interval] /= tot_w
                # Only consider intervals with a high enough curvature
                active[interval] = curvatures[interval] > max_curvature
            end
        end
        # Approximate end intervals as being the same curvature as those next to it.
        # This avoids computing the function ∈ the end points
        curvatures[1] = curvatures[2]
        active[1] = active[2]
        curvatures[end] = curvatures[end - 1]
        active[end] = active[end - 1]

        all(x -> x ≥ max_recursions, n_tot_refinements[active]) && break

        n_target_refinements = n_intervals ÷ 2
        interval_candidates = collect(1:n_intervals)[active]
        n_refinements = min(n_target_refinements, length(interval_candidates))
        perm = sortperm(curvatures[active])
        intervals_to_refine =
            sort(interval_candidates[perm[(length(perm) - n_refinements + 1):end]])
        n_intervals_to_refine = length(intervals_to_refine)
        n_new_points = 2 * length(intervals_to_refine)

        # Do division of the intervals
        new_xs = zeros(eltype(xs), n_points + n_new_points)
        new_fs = zeros(eltype(fs), n_points + n_new_points)
        new_tot_refinements = zeros(Int, n_intervals + n_intervals_to_refine)
        k = kk = 0
        for i in 1:n_points
            if iseven(i) # This is a point ∈ an interval
                interval = i ÷ 2
                if interval ∈ intervals_to_refine
                    kk += 1
                    new_tot_refinements[interval - 1 + kk] = n_tot_refinements[interval] + 1
                    new_tot_refinements[interval + kk] = n_tot_refinements[interval] + 1

                    k += 1
                    new_xs[i - 1 + k] = (xs[i] + xs[i - 1]) / 2
                    new_fs[i - 1 + k] = g(new_xs[i - 1 + k])

                    new_xs[i + k] = xs[i]
                    new_fs[i + k] = fs[i]

                    new_xs[i + 1 + k] = (xs[i + 1] + xs[i]) / 2
                    new_fs[i + 1 + k] = g(new_xs[i + 1 + k])
                    k += 1
                else
                    new_tot_refinements[interval + kk] = n_tot_refinements[interval]
                    new_xs[i + k] = xs[i]
                    new_fs[i + k] = fs[i]
                end
            else
                new_xs[i + k] = xs[i]
                new_fs[i + k] = fs[i]
            end
        end

        xs = new_xs
        fs = new_fs
        n_tot_refinements = new_tot_refinements
        n_points = n_points + n_new_points
        n_intervals = n_points ÷ 2
    end

    return xs, fs
end

# The following `tryrange` code was copied from Plots.jl
# https://github.com/JuliaPlots/Plots.jl/blob/15dc61feb57cba1df524ce5d69f68c2c4ea5b942/src/series.jl#L399-L416

"""
    tryrange(F, vec)

Tries to call the callable `F` (which must accept one real argument)
and determine when it executes without error.

If `F` is an `AbstractArray`, it will find the first element of `vec`
for which all callables ∈ `F` execute.
"""
function tryrange(F, vec)
    for v in vec
        try
            tmp = F(v)
            return v
        catch
        end
    end
    error("$F is not a Function, or is not defined at any of the values $vec")
end

# try some intervals over which the function may be defined

function tryrange(F::AbstractArray, vec)
    rets = [tryrange(f, vec) for f in F] # get the preferred for each
    maxind = maximum(indexin(rets, vec)) # get the last attempt that succeeded (most likely to fit all)
    rets .= [tryrange(f, vec[maxind:maxind]) for f in F] # ensure that all functions compute there
    return rets[1]
end
